[POJ]P3126 Prime Path[BFS]

[POJ]P3126

Prime Path

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 35230   Accepted: 18966

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don‘t know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source

Northwestern Europe 2006


两年没写了,现在已经真的菜爆了。

本题大致意思,给你两个四位的素数,一个是起始状态,另一个是终止状态,要使起始状态变为终止状态每一步可进行的操作为,将这个四位数的某一位更换,但要求新的数也必须是一个素数,问最少步数。

大致思路也比较简单,就是先欧拉线性筛把所有素数先筛出来,再用在线处理的方式bfs。(然而我bfs写炸了好几次...)

代码:

#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;
const int Maxn = 10010 ;
const int inf = 100000000 ;
namespace iNx{
    struct qq{
        int num;
        int c;
    };
    qq q[Maxn];
    int primer[Maxn],pos[Maxn];
    bool check[Maxn],exist[Maxn];
    int cnt,best;
    void Euler(){
        memset(check,1,sizeof check);
        int i,j;
        check[1]=false ;
        for(i=2;i<10000;i++){
            if(check[i]) primer[++cnt]=i;
            for(j=1;j<=cnt&&(i*primer[j]<10000);j++){
                check[i*primer[j]]=false ;
                if(i%primer[j]==0) break ;
            }
        }
    }
    int getn(int a,int i){
        if(i==1) return a%10;
        if(i==2) return (a/10)%10;
        if(i==3) return (a/100)%10;
        return a/1000;
    }
    void bfs(int a,int b){
        int head=1,tail=1;
        q[1].num=a;
        q[1].c=0;
        int i,j,h,k,m,t;
        while(tail>=head){
            h=q[head].num;
            if(h==b){
                printf("%d\n",q[head].c);
                break ;
            }
            exist[h]=true ;
            for(i=1;i<=4;i++){
                k=getn(h,i);
                for(j=1,m=1;j<i;j++) m*=10;
                for(j=0;j<=9;j++){
                    if(i==4&&j==0) continue ;
                    if(j==k) continue ;
                    t=h+j*m-k*m;
                    if(check[t]&&(!exist[t])){
                        q[++tail].num=t;
                        q[tail].c=q[head].c+1;
                    }
                }
            }
            head++;
        }
    }
    int main(){
        Euler();
        int n,a,b,i;
        scanf("%d",&n);
        for(i=1;i<=n;i++){
            scanf("%d%d",&a,&b);
            memset(exist,0,sizeof exist);
            bfs(a,b);
        }
        return 0;
    }
}
int main(){
    iNx::main();
    return 0;
}

现在要开始天天练习了,蒟蒻我太难了。

原文地址:https://www.cnblogs.com/Liisa/p/11478805.html

时间: 2024-08-08 06:59:38

[POJ]P3126 Prime Path[BFS]的相关文章

poj 3126 Prime Path (bfs)

Prime Path Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 13813   Accepted: 7796 Description The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-dig

POJ 3126 Prime Path(BFS 数字处理)

题意  给你两个4位素数a, b  你每次可以改变a的一位数但要求改变后仍为素数  求a至少改变多少次才能变成b 基础的bfs  注意数的处理就行了  出队一个数  然后入队所有可以由这个素数经过一次改变而来的素数  知道得到b #include <cstdio> #include <cstring> using namespace std; const int N = 10000; int p[N], v[N], d[N], q[N], a, b; void initPrime(

POJ 3126 Prime Path bfs 简单

给出2个四位数的素数a,b,要求a每次变化只可以变a的4个数字的其中一个,并且变化后的数也要是素数,问a至少要变化多少次才可以变为b. 注意,a的千位数不能变化为0 先打出素数表,再bfs数a即可. 1 #include<cstdio> 2 #include<cstring> 3 #include<queue> 4 5 using namespace std; 6 7 const int maxn=10010; 8 const int inf=0x3f3f3f3f; 9

POJ 3126 Prime Path (BFS+剪枝)

题目链接:传送门 题意: 给定两个四位数a,b,每次可以改变a的任意一位,并且确保改变后的a是一个素数. 问最少经过多少次改变a可以变成b. 分析: BFS,每次枚举改变的数,有一个剪枝,就是如果这个改变的数之前已经得到过了, 就没有必要继续变回它了. 代码如下: #include <iostream> #include <cstring> #include <algorithm> #include <cstdio> #include <queue&g

POJ 3126 Prime Path (BFS + 素数筛)

链接 : Here! 思路 : 素数表 + BFS, 对于每个数字来说, 有四个替换位置, 每个替换位置有10种方案(对于最高位只有9种), 因此直接用 BFS 搜索目标状态即可. 搜索的空间也不大... /************************************************************************* > File Name: E.cpp > Author: > Mail: > Created Time: 2017年11月26日

poj 3126 Prime Path 【暴力BFS】

题意:给你一个4位数,再给你一个4位数,如前一个数的每次只移动一位,问你能不能将第一个数变成第二个. 转移条件:1,只能通过素数作为中转,2,每次移动一位. 如果找到输出最少的转移次数(或步数), 如果找不到输出Impossible. 策略:如题. 直接上代码: #include<stdio.h> #include<string.h> #include<queue> #define M 10005 using std::queue; int vis[10000]; in

双向广搜 POJ 3126 Prime Path

POJ 3126  Prime Path Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 16204   Accepted: 9153 Description The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change th

POJ 3126 Prime Path(素数路径)

p.MsoNormal { margin-bottom: 10.0000pt; font-family: Tahoma; font-size: 11.0000pt } h1 { margin-top: 5.0000pt; margin-bottom: 5.0000pt; text-align: left; font-family: 宋体; font-weight: bold; font-size: 24.0000pt } span.10 { font-family: "Times New Rom

POJ 3126 Prime Path SPFA

http://poj.org/problem?id=3126 题目大意: 给你两个四位的素数s和t,要求每次改变一个数字,使得改变后的数字也为素数,求s变化到t的最少变化次数. 思路: 首先求出所有4位素数. 对于两个素数之间,如果只相差一个数字,那么就建立图,(双向) 最后求最短路即可(可以SPFA也可以BFS) #include<cstdio> #include<cstring> #include<queue> #include<algorithm> u